################################################################################
# KerA broker
################################################################################
- hosts: cloud.keraf.1.broker
  prepare:
    - debug:
        msg: "Changing ownership of the Plasma socket"
    - shell: "docker exec task_manager chown flink:flink /tmp/plasma"
  finalize:
    - debug:
        msg: "Stopping KerA broker"
    - shell: "docker stop kera_broker || true && docker rm kera_broker || true"
    - debug:
        msg: "Removing the Plasma socket"
    - shell: "rm -f /tmp/plasma"

################################################################################
# KerA coordinator
################################################################################
- hosts: cloud.keraf.1.coordinator
  finalize:
    - debug:
        msg: "Stopping KerA coordinator"
    - shell: "docker stop kera_coordinator || true && docker rm kera_coordinator || true"

################################################################################
# KerFlink Task Manager
################################################################################
- hosts: cloud.keraf.1.task_manager
  prepare:
    - debug:
        msg: "Preparing application-specific files"
    - shell: "docker exec task_manager mkdir -p /opt/enwiki
              && docker exec task_manager touch /opt/enwiki/enwiki1
              && docker exec task_manager chown -R flink:flink /opt/enwiki"
    - debug:
        msg: "Copying Java bindings"
    - shell: "docker exec task_manager cp /opt/kera/install/lib/kera/kera_jni.jar /opt/flink/lib/
              && docker exec task_manager chown -R flink:flink /opt/flink/lib/"
  finalize:
    - debug:
        msg: "Stopping Flink Task Manager"
    - shell: "docker stop task_manager || true && docker rm task_manager || true"

################################################################################
# KerFlink Job Manager
################################################################################
- hosts: cloud.keraf.1.job_manager
  depends_on:
    - service_selector: "cloud.keraf.1.job_manager"
      grouping: "round_robin"
      prefix: "flink_jobmanager"
  prepare:
    - debug:
        msg: "Copying the Flink job"
    - copy:
        src: "{{ working_dir }}/flink-consumer-1.jar"
        dest: "/opt/flink-consumer-1.jar"
    - shell: "docker cp /opt/flink-consumer-1.jar job_manager:/opt/"
    - debug:
        msg: "Preparing application-specific files"
    # The following command is necessary on the job manager, didn't understand why
    - shell: "docker exec job_manager mkdir -p /opt/enwiki
              && docker exec job_manager touch /opt/enwiki/enwiki1
              && docker exec job_manager chown -R flink:flink /opt/enwiki"
    - debug:
        msg: "Copying Java bindings"
    # Copy the Java bindings to the remote /opt/flink/lib
    - shell: "docker exec job_manager cp /opt/kera/install/lib/kera/kera_jni.jar /opt/flink/lib/
              && docker exec job_manager chown -R flink:flink /opt/flink/lib/"
    - debug:
        msg: "Copying the Flink job"
    - copy:
        src: "{{ working_dir }}/flink-consumer-1.jar"
        dest: "/opt/flink-consumer-1.jar"
    - shell: "docker cp /opt/flink-consumer-1.jar job_manager:/opt/"
  launch:
    - debug:
        msg: "Starting flink-consumer-1 job"
    # Make sure to provide the path to the Java bindings using the classpath parameter.
    # These bindings are copied in the Flink /lib directory after the JM and TMs
    # are being started, which makes the default classloading fail.
    - shell: "docker exec job_manager flink run -d
                --classpath file:///opt/flink/lib/kera_jni.jar
                /opt/flink-consumer-1.jar
                --topic streamName
                --inputdir /opt/enwiki
                --numberConsumers 1
                --maxThroughputCons 1000000
                --streamId 1
                --recordsCount 100000
                --numberNodes 1
                --nStreamlets 1
                --nActiveGroups 1
                --batchSize 12000
                --nrecordsThrottle 10000000
                --totalObjectsSize 800000000
                --locator tcp:host={{ flink_jobmanager.__address__ }},port=11100
                --clusterName test
                --numberTaskManagers 1"
  finalize:
    - debug:
        msg: "Stopping Flink Job Manager"
    - shell: "docker stop job_manager || true && docker rm job_manager || true"